package org.jvnet.jaxbcommons.addon;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.springframework.beans.factory.config.AutowireCapableBeanFactory;
import org.springframework.context.support.AbstractXmlApplicationContext;
import org.springframework.context.support.FileSystemXmlApplicationContext;

public abstract class AbstractApplicationContextAwareCodeAugmenter extends
		AbstractParameterizableCodeAugmenter {

	protected Log logger = LogFactory.getLog(getClass());

	private AbstractXmlApplicationContext applicationContext;

	private boolean dependencyCheck = false;

	public void setDependencyCheck(boolean dependencyCheck) {
		this.dependencyCheck = dependencyCheck;
	}

	public boolean isDependencyCheck() {
		return dependencyCheck;
	}

	public AbstractXmlApplicationContext getApplicationContext() {
		return applicationContext;
	}

	private String config;

	public String getConfig() {
		return config;
	}

	public void setConfig(String config) {
		this.config = config;
		logger.debug("Loading configuration from [" + config + "].");
		try {
			applicationContext = new FileSystemXmlApplicationContext(
					new String[] { "file:" + config }, false);
			applicationContext.setClassLoader(getClass().getClassLoader());
			applicationContext.refresh();
			this.applicationContext.getBeanFactory().autowireBeanProperties(
					this, AutowireCapableBeanFactory.AUTOWIRE_BY_TYPE,
					isDependencyCheck());
		} catch (Exception ex) {
			ex.printStackTrace();
			throw new RuntimeException(ex);
		}
	}
}
