package org.jvnet.jaxbcommons.addon;

import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.jvnet.jaxbcommons.util.FieldUtils;
import org.xml.sax.ErrorHandler;

import com.sun.tools.xjc.CodeAugmenterEx;
import com.sun.tools.xjc.Options;
import com.sun.tools.xjc.generator.ClassContext;
import com.sun.tools.xjc.generator.GeneratorContext;
import com.sun.tools.xjc.grammar.AnnotatedGrammar;
import com.sun.tools.xjc.grammar.ClassItem;
import com.sun.tools.xjc.grammar.FieldItem;
import com.sun.tools.xjc.grammar.FieldUse;

public abstract class AbstractProcessingAddOn extends AbstractApplicationContextAwareCodeAugmenter
    implements
    CodeAugmenterEx {

  protected Log logger = LogFactory.getLog(getClass());

  public boolean run(
      AnnotatedGrammar grammar,
      GeneratorContext context,
      Options opt,
      ErrorHandler errorHandler) {

    final ClassItem[] classItems = grammar.getClasses();

    for (int index = 0; index < classItems.length; index++) {
      final ClassItem classItem = classItems[index];

      final ClassContext classContext = context.getClassContext(classItem);
      final List fieldItems = getFieldUses(classContext);

      getClassItemProcessor().process(classContext);

      for (Iterator iterator = fieldItems.iterator(); iterator.hasNext();) {
        final FieldItem fieldItem = (FieldItem) iterator.next();
        getClassItemProcessor().process(classContext, fieldItem);
      }
    }
    return true;
  }

  protected List getFieldUses(final ClassContext classContext) {

    final FieldUse[] fieldUses = FieldUtils.getFieldUses(classContext.target);
    final List fieldItems = new ArrayList(fieldUses.length);
    for (int jndex = 0; jndex < fieldUses.length; jndex++) {
      final FieldUse fieldUse = fieldUses[jndex];
      final FieldItem fieldItem = FieldUtils.getFieldItem(fieldUse);
      fieldItems.add(fieldItem);
    }
    return fieldItems;
  }

  public abstract ClassItemProcessor getClassItemProcessor();

  public interface ClassItemProcessor {
    public void process(ClassContext classContext);

    public void process(ClassContext classContext, FieldItem fieldItem);
  }
}
