package org.jvnet.jaxbcommons.enums.addon.generator;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.Map;

import org.jvnet.jaxbcommons.addon.generator.AbstractMethodStrategy;

import com.sun.codemodel.JCodeModel;
import com.sun.codemodel.JDefinedClass;
import com.sun.codemodel.JExpr;
import com.sun.codemodel.JMethod;
import com.sun.codemodel.JMod;
import com.sun.codemodel.JOp;
import com.sun.codemodel.JVar;
import com.sun.tools.xjc.generator.ClassContext;
import com.sun.tools.xjc.grammar.FieldItem;

public class GetEnumCodeMapStrategy extends AbstractMethodStrategy {

  private final Map processedClassesMap = new HashMap();

  public JMethod generate(ClassContext classContext, FieldItem fieldItem, JDefinedClass theClass) {

    if (processedClassesMap.keySet().contains(theClass)) {
      return (JMethod) processedClassesMap.get(theClass);

    }
    else {
      final JCodeModel codeModel = getCodeModel(classContext);

      final JVar enumCodeMap = theClass.field(JMod.PRIVATE + JMod.STATIC, Map.class, "enumCodeMap");

      final JMethod constructor = (JMethod) theClass.constructors().next();
      constructor.body()._if(JOp.eq(enumCodeMap, JExpr._null()))._then().assign(
          enumCodeMap,
          JExpr._new(codeModel.ref(HashMap.class)));

      constructor.body().invoke(enumCodeMap, "put").arg(JExpr._this()).arg(JExpr.ref("v"));

      final JMethod getEnumCodeMap = theClass.method(JMod.PUBLIC | JMod.STATIC, codeModel
          .ref(Map.class), "getEnumCodeMap");
      getEnumCodeMap.body()._return(enumCodeMap);
      processedClassesMap.put(theClass, getEnumCodeMap);
      return getEnumCodeMap;
    }
  }
}
