package org.jvnet.jaxbcommons.tree.addon.generator;

import org.jvnet.jaxbcommons.addon.generator.AbstractMethodStrategy;
import org.jvnet.jaxbcommons.addon.generator.MethodStrategy;
import org.jvnet.jaxbcommons.tree.Node;
import org.jvnet.jaxbcommons.tree.NodeCreator;
import org.jvnet.jaxbcommons.util.ClassUtils;
import org.jvnet.jaxbcommons.util.FieldUtils;

import com.sun.codemodel.JArray;
import com.sun.codemodel.JBlock;
import com.sun.codemodel.JClass;
import com.sun.codemodel.JCodeModel;
import com.sun.codemodel.JDefinedClass;
import com.sun.codemodel.JExpr;
import com.sun.codemodel.JExpression;
import com.sun.codemodel.JInvocation;
import com.sun.codemodel.JMethod;
import com.sun.codemodel.JMod;
import com.sun.codemodel.JVar;
import com.sun.tools.xjc.generator.ClassContext;
import com.sun.tools.xjc.grammar.FieldItem;

public class CreateNodeStrategy extends AbstractMethodStrategy {

  private MethodStrategy fieldNodeStrategy = new CreateFieldNodeStrategy();

  public MethodStrategy getFieldNodeStrategy() {
    return fieldNodeStrategy;
  }

  public void setFieldNodeStrategy(MethodStrategy fieldNodeStrategy) {
    this.fieldNodeStrategy = fieldNodeStrategy;
  }

  public JMethod generate(ClassContext classContext, FieldItem ignored, JDefinedClass theClass) {
    final JCodeModel codeModel = getCodeModel(classContext);
    ClassUtils._implements(classContext.ref, codeModel.ref(NodeCreator.class));

    final JClass nodeClass = codeModel.ref(Node.class);
    final JClass nodeArrayClass = nodeClass.array();

    final JMethod createNode = theClass.method(JMod.PUBLIC, Node.class, "createNode");
    final JVar name = createNode.param(String.class, "name");

    final JBlock body = createNode.body();

    final JArray nodesArrayExpression = JExpr.newArray(nodeArrayClass);

    final FieldItem[] fieldItems = FieldUtils.getFieldItems(classContext);

    final MethodStrategy fieldNodeStrategy = getFieldNodeStrategy();

    for (int index = 0; index < fieldItems.length; index++) {
      final FieldItem fieldItem = fieldItems[index];
      final JMethod createFieldNodes = fieldNodeStrategy
          .generate(classContext, fieldItem, theClass);

      final JVar fieldNodes = body.decl(JMod.FINAL, nodeArrayClass, "the"
          + fieldItem.name
          + "Nodes", JExpr.invoke(createFieldNodes));
      nodesArrayExpression.add(fieldNodes);
    }

    final JVar nodesArray = body.decl(JMod.FINAL, nodeArrayClass.array(), "nodesArray", nodesArrayExpression);

    final JInvocation newNode = JExpr._new(nodeClass).arg(name).arg(
        classContext.ref.staticRef("class")).arg(JExpr._this()).arg(nodesArray);
    final JVar node = body.decl(JMod.FINAL, nodeClass, "node", newNode);
    body._return(node);
    return createNode;
  }

}
