package org.jvnet.jaxbcommons.util;

import java.util.ArrayList;
import java.util.Collection;
import java.util.Iterator;

import org.jvnet.jaxbcommons.xml.bind.ContextPathAware;

import com.sun.codemodel.JClass;
import com.sun.codemodel.JCodeModel;
import com.sun.codemodel.JDefinedClass;
import com.sun.codemodel.JExpr;
import com.sun.codemodel.JMethod;
import com.sun.codemodel.JMod;
import com.sun.codemodel.JPackage;
import com.sun.tools.xjc.generator.GeneratorContext;
import com.sun.tools.xjc.generator.PackageContext;
import com.sun.tools.xjc.grammar.AnnotatedGrammar;

public class GeneratorContextUtils {

  private GeneratorContextUtils() {
  }

  public static String getContextPath(GeneratorContext context) {
    final StringBuffer sb = new StringBuffer();
    final PackageContext[] packageContexts = context.getAllPackageContexts();
    for (int index = 0; index < packageContexts.length; index++) {
      final PackageContext packageContext = packageContexts[index];
      final String packageName = (String) packageContext._package.name();
      sb.append(packageName);
      if (index < packageContexts.length - 1)
        sb.append(':');
    }
    return sb.toString();
  }

  public static JDefinedClass generateContextPathAwareClass(
      AnnotatedGrammar grammar,
      GeneratorContext generatorContext,
      String name,
      Class theClass) {

    return generateContextPathAwareClass(grammar, generatorContext, name, theClass == null
        ? null
        : grammar.codeModel.ref(theClass));
  }

  public static JDefinedClass generateContextPathAwareClass(
      AnnotatedGrammar grammar,
      GeneratorContext generatorContext,
      String name,
      JClass baseClass) {

    final String contextPath = GeneratorContextUtils.getContextPath(generatorContext);

    final JCodeModel codeModel = grammar.codeModel;
    final JDefinedClass contextPathAwareClass = CodeModelUtils.getOrCreateClass(
        codeModel,
        JMod.PUBLIC,
        name);

    ClassUtils._implements(contextPathAwareClass, codeModel.ref(ContextPathAware.class));

    if (baseClass != null)
      contextPathAwareClass._extends(baseClass);

    final JMethod getContextPath = contextPathAwareClass.method(JMod.PUBLIC, codeModel
        .ref(String.class), "getContextPath");
    getContextPath.body()._return(JExpr.lit(contextPath));
    return contextPathAwareClass;
  }

}
